/*
  Copyright (C) 1997-2014 Sam Lantinga <slouken@libsdl.org>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely.
*/
/* Simple program:  Move N sprites around on the screen as fast as possible */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/stat.h>
struct stat st

#include <SDL2/SDL.h>

//#include <X11/X.h>
//#include "xcb_hello_inc.c"
//for skell

#define WINDOW_WIDTH    600
#define WINDOW_HEIGHT   520
#define NUM_SPRITES     100
#define MAX_SPEED       1
#define spx 4
#define spy 2

SDL_Window *window
SDL_Renderer *renderer
SDL_Texture *wintex
SDL_Surface *winsurf,*winsurf1 ;SDL_Surface *ap_surf,*ap_surf2
double zoom=1 ;//>1 is bigger
float zoomcx= 84*4-2, zoomcy= 92*2-1
char dirty=0

/*#define coabx(cx) (((cx)-zoomcx)*zoom-fwin.source.x)
#define coaby(cy) (((cy)-zoomcy)*zoom-fwin.source.y)
#define coordx(abx) (((abx)+fwin.source.x)/zoom+zoomcx)
#define coordy(aby) (((aby)+fwin.source.y)/zoom+zoomcy)*/
#define coabx(cx) (((cx)-0)*zoom+fwin.dest.w/2+fwin.source.x)
#define coaby(cy) (((cy)-0)*zoom+fwin.dest.h/2+fwin.source.y)
#define coordx(abx) (((abx)-fwin.dest.w/2-fwin.source.x)/zoom+0)
#define coordy(aby) (((aby)-fwin.dest.h/2-fwin.source.y)/zoom+0)

#define stif(x) #x
#define printq(format,...) printf(stif(format %s\n),__VA_ARGS__,stif((format,##__VA_ARGS__)))

static SDL_Texture *sprite
static SDL_Rect positions[NUM_SPRITES]
static SDL_Rect velocities[NUM_SPRITES]
static int sprite_w, sprite_h

#define sif(a) #a
//#define sdl(b,a,...) sdl_=(void*)SDL_ ## a(__VA_ARGS__);if((int)sdl_<(strcmp(sif(typeof(SDL_##a)),"int")!=0)){printf("SDL_%s failed: %s %s\n",#a, SDL_GetError(),sif(typeof(SDL_##a)));quit(2);}
//#define sdl(b,a) if((int)(a)<b){printf("SDL_ failed: %s\n", SDL_GetError());quit(2);}
void* sdl_v
#define sdl_(c,b,a,...) sdl_v=(void*)c ## a(__VA_ARGS__);if((int)sdl_v<b){printf("SDL_%s failed: %s\n",#a, SDL_GetError());quit(2);}
#define sdl(b,a,...) sdl_(SDL_,b,a,__VA_ARGS__)

typedef int rectv
struct Rect
	rectv x ;//sometimes used as p pitch
	rectv y
	rectv w
	rectv h
	char m  ;//null mask
;//
#define rectm struct Rect
typedef struct drectm
	rectv x,y,w,h
	rectv a,b,c,d
	char m ;//if a bit is zero then it is the last rectv //obviously you may typecast to rectv*
drectm;//
struct Frame
	char *title
	char *file_path
	rectm source
	rectm dest
	rectm  vsource
	rectm  vdest
	SDL_Texture* textu
	struct Frame **cframes
	int cfwidth
;//
#define Frame struct Frame
Frame (*tt)[]
Frame fwin
FILE* conf
char* ofn

/* Call this instead of exit(), so we can clean up SDL: atexit() is evil. */
/*static*/ void quit(int rc)
	exit(rc)
#define A(a,b) (a).b
#define B(a,b) A(*a,b)
#define add_rect(rekt,r2) set_rectm(rekt,(rekt)->x+(r2).x,(rekt)->y+(r2).y,(rekt)->w+(r2).w,(rekt)->h+(r2).h,0)
void set_rectm(rectm* rekt,int x,int y,int w,int h,char m) 
#define print_rekt(r) printf("%s %d %d %d %d\n",#r,(r).x,(r).y,(r).w,(r).h)
void present_wrap1()
	/*look at example code SDL_GetWindowSurface.html*/
	static SDL_Surface *s
	if(!s)
		s=sdl(1,GetWindowSurface,window)
	SDL_BlitSurface(winsurf, NULL, s, NULL)
	// this works just like SDL_Flip
	SDL_UpdateWindowSurface(window)
void present_wrap()
	sdl(0,SetRenderTarget,renderer,NULL)
	SDL_RenderCopy(renderer, wintex, NULL, NULL)
	static SDL_Texture *t,*t1
	if(1)
		t=sdl(1,CreateTextureFromSurface,renderer,winsurf)
		t1=sdl(1,CreateTextureFromSurface,renderer,winsurf1)
		SDL_RenderCopy(renderer, t, NULL, NULL)
		SDL_RenderCopy(renderer, t1, NULL, NULL)
	SDL_RenderPresent(renderer)
	if(1)
		SDL_DestroyTexture(t)
		SDL_DestroyTexture(t1)
	sdl(0,SetRenderTarget,renderer,wintex)
rectm zoom_rect(rectm* r)
	rectm s
	set_rectm(&s,coabx(r->x),coaby(r->y),(r->w)*zoom,(r->h)*zoom,0)
	return s
void intersect(Frame*src,Frame*sub)
	rectm* dest1=&sub->vdest
	set_rectm(dest1,sub->dest.x,sub->dest.y,sub->source.w,sub->source.h,0)
	*dest1=zoom_rect(dest1)
	SDL_RenderCopy(renderer, sub->textu, &sub->source,dest1)
	return
	//below broken more for zoom
	//above and below (current issue), the edges wrong for zoom!=1
	print_rekt(src->source)
	print_rekt(src->dest)
	print_rekt(sub->source)
	print_rekt(sub->dest)

	rectm adjust
	set_rectm(&adjust,0,0,0,0,0)
	static int off,out,out_x,out_y
	#define this(x,w)	\;
		out= sub->dest.x - src->source.x	;\;
		if(out<0){adjust.w+=out;adjust.x-=out;}	;\;
		off=out+ sub->source.w - src->source.w	;\;
		if(off>0) adjust.w-=off	;\;
		off= sub->source.w +adjust.w	;\;
		if(off<0) adjust.w-=off
	this(x,w)
	out_x=out
	this(y,h)
	out_y=out
	set_rectm(&(sub->vsource),sub->source.x,sub->source.y,sub->source.w,sub->source.h,0)
	set_rectm(&(sub->vdest),out_x,out_y,sub->source.w,sub->source.h,0)
	//add_rect(&(sub->vdest),adjust);add_rect(&(sub->vsource),adjust)
	print_rekt(adjust)
	rectm what,w2
	what=(sub->vsource) ;w2=zoom_rect(&(sub->vdest))
	SDL_RenderCopy(renderer, sub->textu, &what,&w2)
void action_cb(Frame*f2,int x,int y)
	//printf("lected %s\n",f->file_path)
	static Frame *f1,fx
	if(!f1) f1=f2
	else
		fx=*f1;*f1=*f2;*f2=fx
		f1=NULL ;script1(0,0)
#define drawall() script1(0,0)
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
rectm intersect2(rectm* rr,rectm* ss)
	rectm t,r,s
	r=*rr ;s=*ss
	t.x=max(r.x,s.x) ;t.y=max(r.y,s.y)
	t.w=min(r.x+r.w,s.x+s.w)-t.x
	t.h=min(r.y+r.h,s.y+s.h)-t.y
	//print_rekt(t)
	return t
Frame* nue_fram_bad(){ Frame fram; return &fram;}
Frame nue_fram()
	Frame fram
	fram.source.m=15
	fram.dest.m=15
	return fram
rectm trect
//#define2 set_rect(r,x1,y1,w1,h1) { r.x=x1;r.y=y1;r.w=w1;r.h=h1}
#define set_rect(r,x1,y1,w1,h1)  r.x=x1;r.y=y1;r.w=w1;r.h=h1
void set_rectm(rectm* rekt,int x,int y,int w,int h,char m) { if(!(m&8))rekt->x=x;if(!(m&4))rekt->y=y;if(!(m&2))rekt->w=w;if(!(m&1))rekt->h=h; rekt->m&=m; }
// a scrollable will always transparently reserve 20 edges for itself-maybe
#define loop_over(f,mac) \;
{ static int j;j=32/*sizeof(f)/sizeof(Frame)*/;printf("j %d\n",j);static int i; i=0;while(i<j){ mac(f,i);i+=1;}}
#define lo(lof,loa)  ( ((*tt)+loa)) /*(*((lof+loa)))*/
//void actionf2(double x,double y)
void actionf(int x,int y)
	//actionf2(x,y)
	rectm r ;//=fwin.source
	set_rectm(&r,x ,y,1,1,0)
	rectm i2
	#define mac_act(f,i) \;
		i2=intersect2(&(lo(f,i)->vdest),&r) ;\;
		if(i2.w>0&&i2.h>0) action_cb(lo(f,i),i2.x,i2.y)
	loop_over(fwin.cframes,mac_act)
void set_width(Frame* f,int width)
	f->cfwidth=width
	rectm* odest=&(lo(f,0)->dest)
	print_rekt(*odest)
	set_rectm(odest,0,0,-1,-1,3)
	int cur_x=odest->x
	int cur_y=odest->y ;int max_height=0
	#define width_cb(f,i) \;
		if(!(i%width)){ cur_x=odest->x; cur_y+=max_height+spy;max_height=0;} ;\;
		lo(f,i)->dest.m=15 ;\;
		set_rectm(&(lo(f,i)->dest),cur_x,cur_y,-1,-1,3) ;\;
		max_height=max(max_height,lo(f,i)->source.h) ;\;
		cur_x+=lo(f,i)->source.w+spx ;\;
		printf("sw %d %d\n",cur_x,cur_y)
	loop_over(f->cframes,width_cb)
char* read_line(FILE* fp)
	static int bm,ac,ln
	static char* out
	bm=ftell(fp) ;ln=0
	while(1)
		fread(&ac,1,1,fp)
		if(ac=='\0'||ac=='\n')break
		ln+=1
	//printf("%d ln\n",ln)
	fseek(fp,bm,0)
	out=malloc(sizeof(char)*(ln+1));*(out+ln)='\0'
	fread(out,ln,1,fp);fread(&ac,1,1,fp)
	printf("%s\n",out)
	return out
char* file_bn(char* fn)
	static char *bn ;bn=fn
	while(*bn!='\0'){bn+=1;}bn-=1
	while(*bn!='/'&&bn>fn-1){bn-=1;}bn+=1
	return bn
#define sjoin(ds,dirn,fn) ds=malloc(sizeof(char)*(strlen(fn)+strlen(dirn)+1)) ;\;
		strcpy(ds,dirn);strcat(ds,fn)
#define mac1(f,i) \;
	fn=*(names+i) ;\;
	tt=f;\;
	if(!((*tt)[i].textu)){ ;\;
		ds=sjoin(ds,dirn,fn) ;\;
		/*printf("ds %s\n",ds)*/ ;\;
		/*printf("fwut %d %d %x %x %x %x\n",i,sizeof(char*),&t,f,tt,lot->cframes)*/ ;\;
		/*(*tt)[0]=nue_fram()*/ ;\;
		/*lo(f,i)->file_path=ds*/ ;\;
		/*(*((*tt)+i))->file_path=ds*/ ;\;
		(*tt)[i].file_path=ds;} ;\;
	loadf(lo(f,i));set_rectm(&(lo(f,i)->source),0,0,80,90,0) ;//0,5,80,80
void script1_lines()
void plot_g(double x,double y,int w)
#define set_gray() SDL_SetRenderDrawColor(renderer, 0xD0, 0xD0, 0xD0, 0xFF*0)
void script1(int xx,int yy)
	//static Frame ok
	//ok=nue_fram()
	Frame *lot=&fwin ;//=nue_fram()
	static int ww,hh;SDL_GetWindowSize(window,&ww,&hh)
	if(wintex&&(ww!=fwin.dest.w||hh!=fwin.dest.h))
		SDL_DestroyTexture(wintex) ;wintex=NULL
	if(!wintex) 
		wintex=sdl(1,CreateTexture,renderer,SDL_PIXELFORMAT_ARGB8888,SDL_TEXTUREACCESS_TARGET,ww,hh)
	if(!winsurf) 
		ap_surf=winsurf=sdl(1,CreateRGBSurface,0,ww,hh,32,255<<8*2,255<<8*1,255,255<<8*3)
	if(!winsurf1)
		winsurf1=sdl(1,CreateRGBSurface,0,ww,hh,32,255<<8*2,255<<8*1,255,255<<8*3)
	sdl(0,FillRect,winsurf,NULL,0x00000000);//0x00FFFFFF)
	sdl(0,SetRenderTarget,renderer,wintex)
	xx=-xx ;yy=-yy
	xx+=lot->source.x ;yy+=lot->source.y
	set_rectm(&(lot->source),xx,yy,ww/zoom,hh/zoom,0)
	lot->dest.m=15
	set_rectm(&(lot->dest),0,0,ww,hh,0)
	//plot_g(100,100,8)

	sdl(0,GetRendererOutputSize,renderer,&ww,&hh)
	printf("ROS %d %d",ww,hh)
	static Frame t[32];lot->cframes=&t
	//t[0].file_path="pibb"
	printf("fwut %d %x %x\n",sizeof(char*),&t,lot->cframes) ;\;
	static char* names[32]
	char *ds;char *fn;char *dirn="/mnt/disk-d/teams/m3/"
	static int started=0
	if(!started)
		static int si
		ofn=sjoin(ofn,dirn,"../m3.order")
		printf("%s\n",ofn)
		ofn="/mnt/disk-d/teams/m3.order"
		conf=fopen(ofn,"rb")
		for(si=0;si<32;si+=1)
			names[si]=read_line(conf)
		fclose(conf)
		started=1
	printf("nyah\n")
	loop_over(lot->cframes,mac1)
	printf("nyah2\n")
	set_width(lot,8)
	static Frame (*cframes2)[]
	
	set_gray()
	//SDL_SetRenderDrawBlendMode(renderer,SDL_BLENDMODE_NONE)
	SDL_RenderClear(renderer)
	#define mac2(f,i) intersect(lot,lo(f,i))
	loop_over(lot->cframes,mac2)
	SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF*1)
	script1_lines()
	dirty=1 ;//present_wrap()
void loadf(Frame* f)
	SDL_Surface *temp
	if(f->textu!=NULL)return

	//define zoom obj->ozoom
	temp=sdl_(IMG_,1,Load,f->file_path)
	if(1*0){
	static char *pix;static int w,h,p
	pix=(char*)temp->pixels;w=temp->w;h=temp->h;p=temp->pitch
	SDL_Palette *pal=temp->format->palette
	SDL_Color *arr; arr=malloc((pal->ncolors+0)*sizeof(SDL_Color))
	printf("first %s %d %d %d\n",f->file_path,*pix,pal->ncolors,pal==NULL)
	*arr=*(pal->colors+*pix)
	int i
	for(i=0;i<pal->ncolors-1;i+=1)
		*(arr+1+i)=*(pal->colors+i)
	sdl(0,SetPaletteColors,pal,arr,0,pal->ncolors+0)
	int first=*pix
	for(i=0;i<p*h;i+=1) if(i%p<w)
		//if(0&&*(pix+i)==first){ *(pix+i)=0 ;} 
		if(0&&*(pix+i)==254){ *(pix+i)=254 ;} ;
		else{ *(pix+i)=*(pix+i)+1 ;}
	rectm lasso
	set_rectm(&lasso,w,h,0,0,0)
	void lasso_f(int x,int y)
		set_rectm(&lasso,min(lasso.x,x),min(lasso.y,y),max(lasso.w,x),max(lasso.h,y),0)
	void flood_i(int x,int y,char colour)
		char my_color=*(pix+y*p+x)
		if(colour==my_color) return
		#define try1(x,y)if(x>=0&&x<w&&y>=0&&y<h){ if(*(pix+y*p+x)==my_color) flood_i(x,y,colour); else { if(*(pix+y*p+x)!=colour) lasso_f(x,y); }}
		#define try(x,y) try1((x),(y))
		*(pix+y*p+x)=colour
		try(x-1,y-1) ;try(x,y-1) ;try(x+1,y-1)
		try(x-1,y) /*;try(x,y)*/;try(x+1,y)
		try(x-1,y+1) ;try(x,y+1) ;try(x+1,y+1)
	void flood(int x,int y,char colour)
		flood_i(x,y,colour)
		set_rectm(&lasso,-1,-1,lasso.w-lasso.x+1,lasso.h-lasso.y+1,12)
	flood(0,0,0+255*0)
	rectm lasso_f2(rectm r)
		rectm s,t
		return r
	//printf("lasso %s ",f->file_path);print_rekt(lasso)
	char* file_p=strdup(f->file_path);strcpy(file_p+strlen(file_p)-3,"bmp")
	if(stat(file_p,&st)) sdl(0,SaveBMP,temp,file_p)
	free(arr);free(file_p)
	}
	//set transparent
	f->textu=sdl(1,CreateTextureFromSurface,renderer, temp)
	set_rectm(&(f->source),-1,-1,temp->w,temp->h,12|~f->source.m)
	//f->dest.m=15

	SDL_FreeSurface(temp)
	//sdl(0,SetRenderTarget,renderer,wintex)
int LoadSprite(char *file, SDL_Renderer *renderer)
	SDL_Surface *temp

	/* Load the sprite image */
	temp = SDL_LoadBMP(file)
	if (temp == NULL)
		SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't load %s: %s\n", file, SDL_GetError())
		return (-1)
	sprite_w = temp->w
	sprite_h = temp->h

	/* Set transparent pixel as the pixel at (0,0) */
	if (temp->format->palette)
		SDL_SetColorKey(temp, SDL_TRUE, *(Uint8 *) temp->pixels)
	else
		switch (temp->format->BitsPerPixel)
			case 15:
				SDL_SetColorKey(temp, SDL_TRUE, ;
								(*(Uint16 *) temp->pixels) & 0x00007FFF)
				break
			case 16:
				SDL_SetColorKey(temp, SDL_TRUE, *(Uint16 *) temp->pixels)
				break
			case 24:
				SDL_SetColorKey(temp, SDL_TRUE, ;
								(*(Uint32 *) temp->pixels) & 0x00FFFFFF)
				break
			case 32:
				SDL_SetColorKey(temp, SDL_TRUE, *(Uint32 *) temp->pixels)
				break

	/* Create textures from the image */
	sprite = SDL_CreateTextureFromSurface(renderer, temp)
	if (!sprite)
		SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create texture: %s\n", SDL_GetError())
		SDL_FreeSurface(temp)
		return (-1)
	SDL_FreeSurface(temp)

	/* We're ready to roll. :) */
	return (0)

void MoveSprites(SDL_Renderer * renderer, SDL_Texture * sprite)
	int i
	int window_w = WINDOW_WIDTH
	int window_h = WINDOW_HEIGHT
	rectm *position, *velocity

	/* Draw a gray background */
	SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF)
	SDL_RenderClear(renderer)

	/* Move the sprite, bounce at the wall, and draw */
	for (i = 0; i < NUM_SPRITES; i+=1)
		position = &positions[i]
		velocity = &velocities[i]
		position->x += velocity->x
		if ((position->x < 0) || (position->x >= (window_w - sprite_w)))
			velocity->x = -velocity->x
			position->x += velocity->x
		position->y += velocity->y
		if ((position->y < 0) || (position->y >= (window_h - sprite_h)))
			velocity->y = -velocity->y
			position->y += velocity->y

		/* Blit the sprite onto the screen */
		SDL_RenderCopy(renderer, sprite, NULL, position)

	/* Update the screen! */
	present_wrap()
void final_save()
	rectm pa,rsrc,rdest,rdestt
	rectm *src=&fwin.source
	SDL_Surface* surf
	static int pitch,depth
	//SDL_RendererInfo ri
	//SDL_Texture*rt=SDL_GetRenderTarget(renderer)
	set_rectm(&pa,-50,-14,734,481,0) ;//h was 440
	//sdl(0,GetRendererInfo,renderer,&ri)
	depth=32 
	void *pix=malloc(depth/8*pa.w*pa.h)
	void *pixie
	pitch=pa.w*(depth/8)
	set_rectm(&rsrc,pa.x,pa.y,src->w,src->h,0)
	while(rsrc.y<pa.y+pa.h)
		while(rsrc.x<pa.x+pa.w)
			set_rectm(&rdestt,pa.x+pa.w-rsrc.x,pa.y+pa.h-rsrc.y,src->w,src->h,0)
			set_rectm(&rdest,0,0,min(rdestt.x,src->w),min(rdestt.y,src->h),0)
			//pitch=depth*(pa.w-(rsrc.x-pa.x))
			pixie=pix+depth/8*(pa.w*(rsrc.y-pa.y)+rsrc.x-pa.x)
			script1(rsrc.x-src->x,rsrc.y-src->y)
			sdl(0,RenderReadPixels,renderer,&rdest,SDL_PIXELFORMAT_ARGB8888,pixie,pitch)
			set_rectm(&rsrc,rsrc.x+rsrc.w,-1,-1,-1,7)
		set_rectm(&rsrc,pa.x,rsrc.y+rsrc.h,-1,-1,3)
	surf=sdl(1,CreateRGBSurfaceFrom,pix,pa.w,pa.h,depth,pitch,0x00FF0000,0x0000FF00,0x000000FF,0xFF000000)
	sdl(0,SaveBMP,surf,"/mnt/disk-d/teams/teams-auto.bmp")
	free(pix)
void regurg_order()
	conf=fopen(ofn,"wb")
	#define mac_rg(f,i) \;
		fprintf(conf,"%s\n",file_bn(lo(f,i)->file_path))
	loop_over(fwin->cframes,mac_rg)
	fclose(conf)
	/*final_save()*/
#define aline(a,b,c,d) sdl(0,RenderDrawLine,renderer,(a),(b),(c),(d))
#define sdir (1) //scroll direction +-1
#define spdir (-1) //scroll direction +-1
void scroll_fp(rectm b1)
	dirty=1 ;//present_wrap() ;//script1(0,0)
	Frame *lot=&fwin
	static int sw,sh
	sw=lot->source.w*zoom
	sh=lot->source.h*zoom
	sdl(0,SetRenderTarget,renderer,NULL)
	aline(0,spdir*(b1.h),sw,spdir*(b1.h))
	aline(0,sh+spdir*(b1.h),sw,sh+spdir*(b1.h))
	aline(spdir*(b1.w),0,spdir*(b1.w),sh)
	aline(sw+spdir*(b1.w),0,sw+spdir*(b1.w),sh)
	SDL_RenderPresent(renderer)
	sdl(0,SetRenderTarget,renderer,wintex)
void scroll_f(rectm b1)
	//print_rekt(b1)
	script1(-sdir*b1.w,-sdir*b1.h)
#include "text_edits.h_"
#include <SDL2/SDL_ttf.h>
#include "sdlfont.h_"
#include "windowevent.h_"
#define dline(a,b,c,d) sdl(0,RenderDrawLine,renderer,coabx(a),coaby(b),coabx(c),coaby(d))
void dlinenope(int a,int b,int c,int d)
	static rectm *src
	src=&(fwin.source)
	//dline1(a-src->x,b-src->y,c-src->x,d-src->y) ;//check bounds?
	printf("%d %d %d %d %d dline\n",(int)zoom,fwin.source.x,fwin.source.y,(int)coabx(5),(int)coaby(6))
void thick_line(int x1,int y1,int x2,int y2,int thn_l,int thn_r)
	static int n
	if(x1==x2)
		for(n=0;n<thn_r;n+=1) dline(x1+n,y1,x2+n,y2)
		for(n=1;n<=thn_l;n+=1) dline(x1-n,y1,x2-n,y2)
	else if(y1==y2)
		for(n=0;n<thn_r;n+=1) dline(x1,y1+n,x2,y2+n)
		for(n=1;n<=thn_l;n+=1) dline(x1,y1-n,x2,y2-n)
	else
		dline(x1,y1,x2,y2) ;//slope?
//
#include "add_pix.c"
#define plot_g_type  void (*)(double x,double y,int w)
void plot_g(double x,double y,int w)
	static int i,j
	static double k,l
	//printf("dbg %f %f %d %d\n",4*coabx(x),4*coabx(y),(int)4*coabx(x),(int)4*coabx(y))
	k=coabx(x)-w/2 ;l=coaby(y)-w/2
	for(i=0;i<w;i+=1)
		for(j=0;j<w;j+=1)
			add_pix(4*(k+i),4*(l+j))
void plot_g_font(double x,double y,int w)
	static int i,j
	static double k,l
	k=x*zoom-w/2 ;l=y*zoom-w/2
	for(i=0;i<w;i+=1)
		for(j=0;j<w;j+=1)
			add_pix2(4*(k+i),4*(l+j))
void plot_g1(double x,double y,int w)
	rectm bob
	bob.x=coabx(x)-w/2 ;bob.y=coaby(y)-w/2 ;bob.w=w ;bob.h=w
	//sdl(0,RenderFillRect,renderer,&bob)
	sdl(0,FillRect,winsurf,&bob,0xFF000000)
void plot_g2_bad(double x,double y,int w)
	//abs(fpart(x)-.5)<=(fpart(y)>.5)-fpart(y) //copix.png
	static int i,j
	static double k,l;static double iptr
	#define fpart(x) modf(x,&iptr)
	#define abs fabs
	rectm bob
	k=coabx(x)-w/2 ;l=coaby(y)-w/2 ;bob.w=1 ;bob.h=1
	for(i=0;i<w;i+=1)
		for(j=0;j<w;j+=1)
			if(abs(fpart(k)-.5)<=((double)(fpart(l)>.5))-fpart(l))
				bob.x=k;bob.y=l
				//sdl(0,RenderFillRect,renderer,&bob)
				sdl(0,FillRect,winsurf,&bob,0xFF000000)
			k+=1
		l+=1;k-=w+1
	#undef abs
//void aline_h()
//void aline_v(char horiz,)
inline void separ(rectm pos/*xy pos w in cells*/,rectm* cell_a/*xy is spacing  wh is wh*/)
	//should be pointer or not? idk inline. static already? or what is const
	#define2 cell (*cell_a){}
	static rectv c ;c=0
	while(c<pos.w)
		qrect(coabx(pos.x),coaby(pos.y),cell.w,cell.h,0xFF000000)
		pos.x+=cell.x ;pos.y+=cell.y
		c+=1
	#include "/tmp/c"
void grid1(const rectm pos/*xy pos wh in cells*/,rectm cell/*xy wh of cell*/)
	static rectm a1,a2
	static rectv tnx=1,tny=1
	set_rect(a1,pos.x,pos.y,pos.w,0 ) ;set_rect(a2,cell.w-tnx,0,tnx,zoom*pos.h*cell.h )
	//please change to inline? but at least macro can't be ignored
	separ(a1,&a2)
	set_rect(a1,pos.x,pos.y,pos.h,0 ) ;set_rect(a2,0,cell.h-tny,zoom*pos.w*cell.w,tny )
	separ(a1,&a2)
void test1_grid1()
	static char never=1
	static rectm r1,r2,a1,a2
	if(never)
		never=0
		set_rectm(&r1,0,0,16,16,0)
		set_rectm(&r2,0,0,150,let_height(150),0)
	set_rectm(&a1,r1.x,r1.y,r1.w,r1.h,0)
	set_rectm(&a2,0,0,r2.w,r2.h,0)
	grid1(a1,a2)
#include "../mlib/lib.h_1"
#include "../mlib/test.h_1"
#include "tiles.h_"
#ifdef solibtest1
#include <dlfcn.h>
void *solib1
#endif
void script1_lines()
	#ifdef solibtest2
	static int solib_v=0
	if(!solib_v)
		solib_v=1
		solib1=dlopen("solib/mm.dso",RTLD_NOW|RTLD_LOCAL|RTLD_DEEPBIND)
	if(solib1!=NULL)
		//"-rdynamic" -ldl
		//(sdl) thread still crashes
		void (*cheddar)(SDL_Surface *winsurf)
		cheddar=dlsym(solib1, "plot_g2")
		if(cheddar!=NULL)
			(*cheddar)(winsurf)
	#endif
	testf()
	ed_mode_func(0,NULL,1,NULL)
	//rendertext(renderer,"apples",0,0,10,NULL,NULL)
	//tiles1()
	//test1_grid1()
	static int t,n,lw,lh
	t=4
	lw=80+spx ;lh=90+spy
	thick_line(lw*4,0,lw*4,lh*4,spx,0)
	n=1 ;thick_line(0,lh*n,lw*8,lh*n,spy,0)
	n=2 ;thick_line(0,lh*n,lw*8,lh*n,spy,0)
	n=3 ;thick_line(0,lh*n,lw*8,lh*n,spy,0)
	//spx 4 spy 2
	//center lw*4-spx/2,lh*2-spy/2   84*4-2,92*2-1
int skell=0
int main(int argc, char *argv[])
	zoom=1
	fwin.source.x=-zoomcx
	fwin.source.y=-zoomcy
	int um=NULL
	if(um==0) printf("yes1\n")
	if(um==NULL) printf("yes2\n")

	int i, done
	SDL_Event event

	/* Enable standard application logging */
	SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO)

	/*if (SDL_CreateWindowAndRenderer(WINDOW_WIDTH, WINDOW_HEIGHT, 0, &window, &renderer) < 0)
		quit(2)
	*///
	if(skell)
		long xid; xid=50331648
		sdl(0,Init,0)
		sdl(0,InitSubSystem,SDL_INIT_EVENTS) //events must be handled by window creator so whats the point
		sdl(0,VideoInit,NULL)
		//xid=hello_main()
		window=sdl(1,CreateWindowFrom,(void *)xid)
	else
		window=sdl(1,CreateWindow,"tsmin", SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, WINDOW_WIDTH,WINDOW_HEIGHT, SDL_WINDOW_RESIZABLE)
	SDL_SetWindowPosition(window,0,40)
	renderer = sdl(1,CreateRenderer,window,-1,SDL_RENDERER_SOFTWARE)

	if (LoadSprite("icon.bmp", renderer) < 0)
		quit(2)

	/* Initialize the sprite positions */
	srand(time(NULL))
	for (i = 0; i < NUM_SPRITES; i+=1)
		positions[i].x = rand() % (WINDOW_WIDTH - sprite_w)
		positions[i].y = rand() % (WINDOW_HEIGHT - sprite_h)
		positions[i].w = sprite_w
		positions[i].h = sprite_h
		velocities[i].x = 0
		velocities[i].y = 0
		while (!velocities[i].x && !velocities[i].y)
			velocities[i].x = (rand() % (MAX_SPEED * 2 + 1)) - MAX_SPEED
			velocities[i].y = (rand() % (MAX_SPEED * 2 + 1)) - MAX_SPEED

	script1(0,0)
	/* Main render loop */
	////while(!skell){}
	done = 0
	while (!done)
		/* Check for events */
		while (SDL_PollEvent(&event))
			if (event.type == SDL_QUIT /*|| event.type == SDL_KEYDOWN*/||(event.type==SDL_WINDOWEVENT && event.window.event==SDL_WINDOWEVENT_CLOSE))
				done = 1
			if(1||skell)
				CheckWEvent(&event)
				CheckBEvent(&event)
				if(dirty)
					dirty=0 ;present_wrap()
				done = done || CheckKEvent(&event)
		//MoveSprites(renderer, sprite)
	regurg_order()
	quit(0)

	return 0; /* to prevent compiler warning */

/* vi: set ts=4 sw=4 expandtab: */
